#include <stdio.h>
#define PI 3.1415

enum{RECTTANGLE, CIRCLE};
struct point{
	int x,y;
}p,*center;
typedef enum {FALSE, TRUE} Bool;
struct shape{
	int shape_kind;
	struct point center;
	union{
		struct{
			int length, width;
		}rectangle;
		struct{
			int radius;
		}circle;
	}u;
}s;

double AreaCompute(struct shape *pShape);
struct point *CenterCompute(struct shape *pShape);
void MoveShape(struct shape *pShape,int dx,int dy);
Bool isWithin(struct shape *pShape, struct point *pPoint);


double AreaCompute(struct shape *pShape){
	if (pShape ->shape_kind==RECTTANGLE){
		return pShape ->u.rectangle.length *pShape ->u.rectangle.width ;
	}
	else if (pShape->shape_kind==CIRCLE){
		return PI *pShape ->u.circle.radius *pShape ->u.circle.radius;
	}
	else
		return 0;
}
struct point *CenterCompute(struct shape *pShape){
	return &(pShape->center);
}
void MoveShape(struct shape *pShape,int dx,int dy){
	pShape->center.x+=dx;
	pShape->center.y+=dy;
}
Bool isWithin(struct shape *pShape, struct point *p){
	if (pShape->shape_kind==RECTTANGLE){
		if (( p->x > pShape->center.x - pShape->u.rectangle.width /2) && (p->x < pShape->center.x+pShape->u.rectangle.width /2) && 
			   ( p->y > pShape->center.y - pShape->u.rectangle.length /2) && (p->y < pShape->center.y+pShape->u.rectangle.length /2))
			return TRUE;
		else	
			return FALSE;
	}
	else if (pShape->shape_kind==CIRCLE){
		if (((p->x * p->x)+(p->y * p->y)) < (pShape->u.circle.radius * pShape->u.circle.radius))
			return TRUE;
		else	
			return FALSE;
		
	}
	else
		return FALSE;

}
int main()
{

	s.shape_kind=RECTTANGLE;	
	s.center.x=10;			
	s.center.y=23;
	s.u.rectangle.length =25;	
	s.u.rectangle.width =8;		
	printf("area of s is %5.2f\n",AreaCompute(&s));
	s.u.rectangle.length =25;	
	s.u.rectangle.width =8;		
	s.u.circle.radius =5;
	printf("area of s is %5.2f\n",AreaCompute(&s));


	center=CenterCompute(&s);
	printf("Center of s is x=%d,y=%d\n",center->x,center->y);
	MoveShape(&s,2,3);
	printf("New s position is x=%d,y=%d\n",s.center.x,s.center.y);
	

	p.x=12;p.y=26;
	if(isWithin(&s,&p)==TRUE){
		printf("point lies within s");
	}
	else
		printf("point does not lie within s");
	getchar();
	return 0;
}

