/*
** pipeMany.c -- a two pipes three child-processes example 
with many reads/writes 
*/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>

int main()
{
  int pfds[2], pfds1[2];
  char buf[30], buf1[30];
  char flag0[30] = {'t', '0', '0', '0'};
  char flag1[30] = {'t', '1', '1', '1'};;

  pipe(pfds);
  pipe(pfds1);
  
  if (!fork()) {
    printf(" CHILD %d: writing to the pipe\n", getpid());
    write(pfds[1], "te00", 5);
    write(pfds[1], "te01", 5);
    write(pfds[1], "t000", 5);
    printf(" CHILD %d: exiting\n", getpid());
    exit(0);
  } else if (!fork()) {
    printf(" CHILD %d: writing to the pipe\n", getpid());
    write(pfds1[1], "te10", 5);
    write(pfds1[1], "te11", 5);
    write(pfds1[1], "t111", 5);
    printf(" CHILD %d: exiting\n", getpid());
    exit(0);
  }
  else if (!fork()) {
    printf(" CHILD %d: reading from pipe\n", getpid());
    while (1) {
      read(pfds1[0], buf1, 5);
      if (strncmp(buf1, flag1, 4) == 0) 
	exit(0); 
      else
	printf(" CHILD %d: read %s\n", getpid(), buf1);
    }
  }   
  else {
    printf("PARENT %d: reading from pipe\n", getpid());
    while(1) {
      read(pfds[0], buf, 5);
      if (strncmp(buf, flag0, 4) == 0) 
	exit(0); 
      else
	printf("PARENT: read \"%s\"\n", buf);
    }
    wait(NULL);
  }
}

