#include <stdlib.h>

/* declare the structure of a tree */

struct tree{              
  int data;
  struct tree *left;
  struct tree *right;
};

typedef struct tree treenode;
typedef treenode *b_tree;            

/* insert a node in the binary tree*/

b_tree insert_node(b_tree root,int node)     
{
  b_tree newnode; 
  b_tree currentnode;
  b_tree parentnode;
  newnode=(b_tree)malloc(sizeof(treenode));       
  /* Allocate space for the new node */
  newnode->data=node;
  newnode->right=NULL;
  newnode->left=NULL;
  
  if(root==NULL)   
    return newnode;
  else
    {   
      currentnode=root;
      while(currentnode!=NULL)
	{   
	  parentnode=currentnode;  
	  if (currentnode->data>node)
	    currentnode=currentnode->left;
	  else   currentnode=currentnode->right;
	}
      if(parentnode->data>node)
	parentnode->left=newnode;
      else  parentnode->right=newnode;
    }
  return root;
}


/* Build a binary tree */
b_tree create_btree(int *data,int len)
{
  b_tree root=NULL; 
  int i;
  for(i=0;i<len;i++)
    root=insert_node(root,data[i]);
  return root;
}


/* inorder traversal */
void inorder(b_tree point){
  if(point!=NULL){
    inorder(point->left);
    printf("%d,",point->data);
    inorder(point->right);
  }
}



/* main function */
int main( )
{
  b_tree root=NULL; 
  int index;
  int value;
  int nodelist[20];
  printf("\n input elements of tree(exit for 0):\n");
  index=0;
  /* read value in arrays */
  scanf("%d",&value);
  while(value!=0)
    {
      nodelist[index]=value; 
      index=index+1;
      scanf("%d",&value);
    }
  /* build binary tree */
  root=create_btree(nodelist,index); 
  /* inorder traversal */
  printf("\nThe inorder traversal result is :");
  inorder(root);
  printf("\n");
  return 0;
}
