#include <stdio.h>
#include <stdlib.h>

#define STACK_SIZE 100
#define TRUE 1
#define FALSE 0

typedef int Bool;

char contents[STACK_SIZE]; /* external */
int top=0;                 /* external */
int count=0;               /* external */

void make_empty(void);
Bool is_empty(void);
Bool is_full(void);
void push(char ch);
char pop(void);
void stack_overflow(void);
void stack_underflow(void);

main()
{
  char ch, popped_char;
  make_empty();
  printf("Enter a series of parentheses and/or braces: ");
  while ((ch = getchar()) != '\n') {
    if (ch == '(' || ch == '{')
      push(ch);
    else if (ch == ')' || ch == '}') {
      popped_char = pop();
      if ((popped_char == '(' && ch == ')') || (popped_char == '{' && ch == '}'))
        continue; 
      else {
        printf("Parentheses/braces are NOT nested properly.\n");
        exit(EXIT_FAILURE);
      }
    }
    else {
      printf("Input should be parentheses and/or braces.\n");
      exit(0);
    }
  }
  if (is_empty())
    printf("Parentheses/braces are nested properly.\n");
  else
    printf("Parentheses/braces are NOT nested properly.\n");
  if (count>0)
    printf("Parentheses/braces are NOT nested properly.\n");   
  return(0);
}


void make_empty(void)
{
  top = 0;
}

Bool is_empty(void)
{
  return top == 0;
}

Bool is_full(void)
{
  return top == STACK_SIZE;
}


void push(char ch)
{
  if (is_full())
    stack_overflow();
  else
    contents[top++] = ch;
}

char pop(void)
{
  if (is_empty())
    stack_underflow();
  else
    return contents[--top];
}

void stack_overflow(void)
{
  printf("Stack overflow\n");
  exit(EXIT_FAILURE);
}

void stack_underflow(void)
{
  count++;
}
